package objectdbtest;

import java.io.File;
import java.net.MalformedURLException;
import java.util.Properties;

import org.apache.felix.framework.FrameworkFactory;
import org.osgi.framework.Bundle;
import org.osgi.framework.BundleException;
import org.osgi.framework.Constants;
import org.osgi.framework.launch.Framework;

public class ObjectDBTest {
	
	public static void main(String[] args) throws BundleException, MalformedURLException{
		System.out.println("Starting Test");
		
		ObjectDBTest test = new ObjectDBTest();
		test.loadOBjectDBBundle();
		
		System.out.println("Test Completed");
	}

	private Framework framework;
	
	private ObjectDBTest() throws BundleException {
		// Dump the previous instance of the framework - clean install
		String felixCacheLocation = "../output/temp/felix-cache";
		deleteDirectory(new File(felixCacheLocation));
		
		Properties props = new Properties();
		props.setProperty(Constants.FRAMEWORK_STORAGE, felixCacheLocation);
		
		// Start the framework
		FrameworkFactory factory = new FrameworkFactory();
		
        framework = factory.newFramework(props);
        framework.init();
        framework.start();
		System.out.println("Framework Started");
	}

	// Load the ObjecDB Bundle
	private void loadOBjectDBBundle() throws MalformedURLException, BundleException {
		File bundleFile = new File("../output/dist/ObjectDBBundle.jar");
		Bundle bundle = this.framework.getBundleContext().installBundle(bundleFile.toURI().toURL().toString());
		bundle.start();
		System.out.println("Bundle Deployed");
	}
	
	// Utility Function to Recursively delete non-empty directories.
	private void deleteDirectory(File file) {
		if(file.isDirectory()){
			for(String subFile : file.list()){
				deleteDirectory(new File(file.getAbsoluteFile() + File.separator + subFile));
			}
		}
		file.delete();
	}
}
